!SFX_LIC Copyright 1994-2014 CNRS, Meteo-France and Universite Paul Sabatier
!SFX_LIC This is part of the SURFEX software governed by the CeCILL-C licence
!SFX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt  
!SFX_LIC for details. version 1.
SUBROUTINE CHOLDC(N,A,P)

USE MODI_ABOR1_SFX

USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB

 IMPLICIT NONE

 INTEGER, INTENT(IN) :: N
 REAL, DIMENSION(N,N), INTENT(INOUT) :: A
 REAL, DIMENSION(N), INTENT(OUT) :: P
 INTEGER :: I
 REAL :: SUMM
 REAL(KIND=JPRB) :: ZHOOK_HANDLE

 IF (LHOOK) CALL DR_HOOK('CHOLDC',0,ZHOOK_HANDLE)
 DO I=1,N

   SUMM = A(I,I)- DOT_PRODUCT(A(I,1:I-1),A(I,1:I-1))

   IF (SUMM <= 0.0) CALL ABOR1_SFX("CHOLDC:ERROR IN CHOLDC")

   P(I) = SQRT(SUMM) 
   A(I+1:N,I) = (A(I,I+1:N) - MATMUL(A(I+1:N,1:I-1),A(I,1:I-1)))/P(I)

 ENDDO

 IF (LHOOK) CALL DR_HOOK('CHOLDC',1,ZHOOK_HANDLE)

END SUBROUTINE CHOLDC 
